<?php
/*
* Santa version 1.2
*
*
*/
Aseco::registerEvent('onStartup', 'santa_startUp');
Aseco::registerEvent('onPlayerConnect', 'santa_connect');
Aseco::registerEvent('onEverySecond', 'santa_tick');
Aseco::registerEvent('onBeginChallenge', 'santa_beg');
Aseco::registerEvent('onPlayerManialinkPageAnswer', 'santa_event');
Aseco::addChatCommand('santa', 'Enables / disables santa');


function chat_santa($aseco, $command) {
	global $santa;
	$params = trim($command['params']);
	$player = $command['author'];
	
	if($aseco->isAnyAdmin($player)) {
		if ($params == "on" ) { 
			$santa->enabled = true; 
			$santa->sendChat("Hou hou hou, Santa is here!");
		}
		if ($params == "off" ) { 
			$santa->enabled = false;
			$santa->sendChat("Hou hou hou, Santa has left the building!");
		}
	}
}


function santa_startUp($aseco, $command) {
global $santa;
$santa = new Santa();
$santa->Aseco = $aseco;
$santa->startUp();
}

function santa_connect($aseco, $command) {
global $santa;
$santa->playerConnect($command);
}

function santa_beg($aseco, $command) {
global $santa;
$santa->beg();
}

function santa_event($aseco, $answer) {
global $santa;
	if($answer[2] == 92021) $santa->doClick($answer[1]);
	if($answer[2] == 92022) $santa->hideWelcome($answer[1]);
}

function santa_tick($aseco) {
global $santa;
$santa->tick();
}

class Santa {

	var $Aseco;
	private $config;
	private $ticks;
	private $timings;
	private $santa = false;
	private $clicked = false;
	public $enabled = true;
	
	function startUp() {
		$xml = simplexml_load_file("santa.xml");
		if(!empty($xml)) {
		$this->config = $xml;
		}
		else 
		{
		 trigger_error('[Santa plugin] Could not read/parse setttings file santa.xml!', E_USER_WARNING);
		 die();
		}
		if ($this->Aseco->server->getGame() == 'TMF' && $this->Aseco->server->rights) {
		 trigger_error('[Santa plugin] Server coppers not enabled!', E_USER_WARNING);
		 die();
		}
		
		$this->setTimings();
		
	}
	
	function tick() {
		$this->ticks++;
		
		if ($this->ticks == $this->timings['gap']) {
			$this->clicked = array();
			if ($this->enabled) $this->display_santa();
			$this->ticks = 0;
			$this->setTimings();
		}
		
	}
		function beg() {
		$this->Aseco->client->query('GetServerCoppers');
			$coppers = $this->Aseco->client->getResponse(); // Get the actual coppers amount from the server
		
			// Total server coppers are higher than the required amount of coppers
			if( (int)$coppers < (int)$this->config->coppers->min_server_coppers ) {
			$this->sendChat((string)$this->config->messages->beg_coppers);
			return;
			}
		}
	function sendChat($message, $login = '') {
	if ($login){
			$this->Aseco->addCall('ChatSendServerMessageToLogin', array($message, $login));
		} else {
			$this->Aseco->addCall('ChatSendServerMessage', array($message));
		}
}	

	function playerConnect($command) {
	$login = $command->login;
	$nick = $command->nickname;
	$this->sendChat((string)$this->config->messages->pl_connect, $login);
	}
	
	
	function display_santa() {
	$x = rand(-63, 50);
	$y = rand(-30, 47);
	$time = $this->timings['display'];
	$image_url = $this->config->server->santa_url;
	$xml = "<manialink id='santa'> 
			<frame posn='$x $y 0'>
			<quad sizen='14 14' posn='0 0 0' image='$image_url' action='92021'/>
			</frame>
			</manialink>";
	$this->Aseco->client->addCall('SendDisplayManialinkPage', array($xml, $time, false));
	}

	function setTimings() {
		$this->timings['gap'] = rand((int)$this->config->timings->gap_min,(int)$this->config->timings->gap_max);
		$this->timings['display'] = rand(((int)$this->config->timings->show_min/100),((int)$this->config->timings->show_max/100))*100;
	}
	
	function doClick($login) {
			if (!isset($this->clicked['first'])) {
			$this->clicked['first'] = $login;
			}
			
			if (!isset($this->clicked[$login])) {
			$this->clicked[$login] = true;			
			} else {
			return;
			}
			
			
			
			$nick = $this->Aseco->server->players->player_list[$login]->nickname;
					
			if ($this->Aseco->server->getGame() == 'TMF' && $this->Aseco->server->rights) {

			$this->Aseco->client->query('GetServerCoppers');
			$coppers = $this->Aseco->client->getResponse(); // Get the actual coppers amount from the server
		
			// Total server coppers are higher than the required amount of coppers
			 if( (int)$coppers < (int)$this->config->coppers->min_server_coppers ) {
			$this->sendChat("\$FF0>> \$FFF $nick \$z\$s Merry Christmas! Sorry, but santa is low for coppers.");
			return;
			} 
			
		/*	if ($this->clicked['first'] == $login) $this->RandomPay( (int)$this->config->changes->first ,$login );
			else $this->RandomPay( (int)$this->config->changes->others , $login ); */
		
			$this->RandomPay( (int)$this->config->chances->other , $login ); 
			$this->Jackpot( (int)$this->config->chances->jackpot , $login );			
		}
		else {
			$this->sendChat("\$FF0>> \$FFF $nick \$z\$, Merry Christmas!",$login);
		}
	} // function
	
	function RandomPay($chance, $login) {
		$prize = rand((int)$this->config->coppers->gift_min,(int)$this->config->coppers->gift_max);
		$rnd = rand(0,100);
		if($rnd <= $chance ){
		$this->Aseco->client->query('Pay', $login, $prize, "Merry Christmas!");
		$this->Announce("youWin",$login,$prize);
		} else {
		$this->Announce("youLose",$login,$prize);
		}
	
	} //function
	
	function Jackpot($chance, $login) {
	$rnd = rand(0,1000);
	if( $rnd <= $chance ){
		$prize = (int)$this->config->coppers->jackpot;
		$this->Aseco->client->query('Pay', $login, $prize, "Merry Christmas!");
		$this->Announce("jackpot",$login,$prize);
		} 
	}

	function Announce($what,$login,$prize) {
	$nick = $this->Aseco->server->players->player_list[$login]->nickname;
		switch ($what) {
		
			case "jackpot":
			$message = (string)$this->config->messages->jackpot[rand(0,count($this->config->messages->jackpot)-1)];
			$message = str_replace("{#prize}",$prize,$message);
			$message = str_replace("{#nick}",$nick,$message);
			$this->sendChat($message);
			break;
			
			case "youWin":
			$message = (string)$this->config->messages->youWin[rand(0,count($this->config->messages->youWin)-1)];
			$message = str_replace("{#prize}",$prize,$message);
			$message = str_replace("{#nick}",$nick,$message);

			$this->sendChat($message); // message to all players
			break;

			case "youLose":
			$message = (string)$this->config->messages->youLose[rand(0,count($this->config->messages->youLose)-1)];
			$message = str_replace("{#nick}",$nick,$message);
			$this->sendChat($message,$login);
			break;
		}
	} //function

} //class

?>
